#include <malloc.h>


/*****************************************************************************
		       Copyright (c) John F. Croix, 1997

			      All Rights Reserved

  Permission to use, copy, modify, and distribute this software and its
  documentation for any non-commercial or internal-use-only purpose and without
  fee is hereby granted, provided that the above copyright notice appears in
  all copies and that both the copyright notice and this permission notice
  appear in supporting documentation, and all changes or alterations to the
  software and documentation are clearly documented.  Resale of any part of
  this software or documentation is prohibited without a license.  Licenses may
  be obtained by contacting the author, John F. Croix, at John.Croix@amd.com or
  journeyman@mail.utexas.edu.

  THE AUTHOR, JOHN F. CROIX, DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
  SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR
  CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
  DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
  TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OF PERFORMANCE
  OF THIS SOFTWARE.
 *****************************************************************************/


/*****************************************************************************
 * This file is used to replace the new and delete operators that would be
 * found in the G++ library.  Since PIPE is a shared library, these functions
 * must be present in the library to guarantee that there are no undefined
 * symbols when loaded by Python.
 *****************************************************************************/


extern "C"
  {
    extern void *__builtin_new(int Size);
    extern void *__builtin_vec_new(int Size);
    extern void __builtin_delete(void *P);
    extern void __builtin_vec_delete(void *P);
  }


void *__builtin_new(int Size)
  {
    return( malloc( Size ) );
  }


void *__builtin_vec_new (int Size)
  {
    return __builtin_new( Size );
  }


void __builtin_delete(void *P)
  {
    if (P)
        free( P );
  }


void __builtin_vec_delete(void *P)
  {
    __builtin_delete( P );
  }

